
#pragma once
#include <glm/common.hpp>
#include <glm/glm.hpp>
#include <variant>
#include "collision.h"
#include <vector>

enum class entity_type {
    STATIC_MESH, 
    BILLBOARD
};

// entity slug
struct entity {
    int id;
    entity_type type;
    int physics;
    int model;
    int light;
};


struct physics_model {
    glm::vec3 pos;
    glm::vec3 velocity;
    glm::mat4 orientation;
    std::vector<collision::Collider> colliders;
};

