

#include "jsonloader.h"

std::optional<glm::vec3> vec3_fromjson(json j) noexcept {
	try {
        glm::vec3 c {j[0], j[1], j[2]};
        return c;
	} catch (std::exception &e) {
		fmt::print("{} {}:{}:: {}", __FUNCTION__, __FILE__, __LINE__, e.what());
        return {};
    }
}


std::optional<glm::vec2> vec2_fromjson(json j) noexcept {
	try {
        glm::vec2 c {j[0], j[1]};
        return c;
	} catch (std::exception &e) {
		fmt::print("{} {}:{}:: {}", __FUNCTION__, __FILE__, __LINE__, e.what());
        return {};
    }
}



